/*

Scrivere un programma per la gestione degli iscritti ad un'aula informatica e le prenotazioni  dei servizi offerti. 
Gli iscritti sono caratterizzati dalle seguenti informazioni: cognome, nome, codice identificativo, tipo di iscritto (0=studente, 1=lavoratore, 2=disoccupato, 3=pensionato).
Le prenotazioni sono caratterizzate dalle seguenti informazioni: codice identificativo iscritto, codice servizio, durata servizio, giorno della settimana  (0=lun, 1=mar, 5=sab).
Gli iscritti sono inseriti in una tabella allocata dinamicamente avente 4 righe, una per ogni  tipo di iscritto.
Le prenotazioni sono inseriti in un vettore di 6 liste, una per ogni giorno della settimana. 


Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1. Inserimento di una nuovo iscritto;
2. Ricerca di un iscritto;
3. Inserimento  nel vettore di liste di una nuova prenotazione; 
4. Eliminazione di tutte le prenotazioni da una lista dopo la loro visualizzazione;
5. Salvataggio su file degli iscritti;

All'avvio del programma inizializzare la tabella degli iscritti leggendo da file gli iscritti  precedentemente salvati.

Liberare la memoria allocata dinamicamente.

*/

#include <stdio.h>
#include <stdlib.h>


struct iscritto
{
       char cognome[20];
       char nome[20];
       int codice;
       int tipo;
};

struct prenotazione
{
       int codice;
       int codservizio;
       int durata;
       int giorno;
};

struct atomo
{
       struct prenotazione dato;
       struct atomo *next;
};


void inizializza(struct iscritto *T[4],int N[4]);
void menu();
void leggi_iscritto(struct iscritto *x);
void ins_iscritto(struct iscritto **R, int *n, struct iscritto x);
void ricerca(struct iscritto *R, int n, int c);
void leggi_prenotazione (struct prenotazione *p);
void in_lista(struct atomo *L[6]);
void da_testa(struct atomo **testa);
void elimina(struct atomo *L[6]);
void salva(struct iscritto *T[4], int *N);

main()
{
      
      struct atomo *L[6],*a;
      struct iscritto *T[4];
      int N[4];
      int i,scelta,tipo,codice;
      struct iscritto x;
      
      
      /*inizializzazione lista*/
      for(i=0;i<6;i++)
         L[i]=NULL;

     /*inizializzazione tabella*/
     for(i=0;i<4;i++)
     {
          T[i]=NULL;
          N[i]=0;
     }
     
     inizializza(T,N);
     
     do
     {
          menu();
          scanf("%d",&scelta);
          switch(scelta)
          {
                        case 1: leggi_iscritto(&x);
                                ins_iscritto(&T[x.tipo],&N[x.tipo],x);
                                break;
                        case 2: printf("Tipo di iscritto:\n");
                                scanf("%d",&tipo);
                                printf("Codice iscritto:\n");
                                scanf("%d",&codice);
                                ricerca(T[tipo],N[tipo],codice);
                                break;
                        case 3: in_lista(L);
                                break;
                        case 4: elimina(L);
                                break;
                        case 5: salva(T,N);
                                break;

                                


          default:;
          }
     }
     while(scelta!=0);
     
     /*liberazione della memoria*/
     for(i=0;i<4;i++)
          free(T[i]);


     for(i=0;i<6;i++)
          while(L[i]!=NULL)
          da_testa(&L[i]);
}
     

void da_testa(struct atomo **testa)
{
     struct atomo *a;
     
     if(a!=NULL)
     {
          a=*testa;
          *testa=a->next;
          free(a);
     }
}


void inizializza(struct iscritto *T[4],int N[4])
{
     FILE *pf;
     struct iscritto x;
    ;
     
     pf=fopen("iscritti.dat","r");
     if(pf!=NULL)
     {
          while(fread(&x,sizeof(struct iscritto),1,pf)>0)
            ins_iscritto(&T[x.tipo],&N[x.tipo],x);
          
          fclose(pf);
     }
     else printf("Errore: file inesistente\n");
}
     
void menu()
{
     printf("Scegli tra:\n");
     printf("1) Inserimento iscritto\n");
     printf("2) Ricerca iscritto\n");
     printf("3) Inserimento prenotazione\n");
     printf("4) Eliminazione di tutte le prenotazioni da una lista\n");
     printf("5) Salvataggio su file degli iscritti\n");
     printf("0) Fine\n");
}

void leggi_iscritto(struct iscritto *x)
{
     printf("Cognome:\n");
     scanf("%s",x->cognome);
     printf("Nome:\n");
     scanf("%s",x->nome);
     printf("Codice identificativo:\n");
     scanf("%d",&x->codice);
     printf("Tipo di iscritto(0=studente,1=lavoratore,2=disoccupato,3=pensionato\n");
     scanf("%d",&x->tipo);
}

void ins_iscritto(struct iscritto **R, int *n, struct iscritto x)
{
     struct iscritto *a;
     
     a=realloc(*R,(*n+1) *sizeof(struct iscritto));
     if(a==NULL)
          return;
     if (a)
     {
      (*R)=a;
      (*R)[*n]=x;
      (*n)++;
     }
}

void ricerca(struct iscritto *R, int n, int c)
{
     int i;
     struct iscritto x;
     
     for(i=0;i<n;i++)
          if(R[i].codice==c)
               break;

     if(i<n) /*trovato*/
     {
             printf("\nNome: %s",R[i].nome);
             printf("\nCognome: %s\n",R[i].cognome);
     }
     else printf("Iscritto non trovato\n");
}

void leggi_prenotazione (struct prenotazione *p)
{
     printf("Codice identificativo:\n");
     scanf("%d",&p->codice);
     printf("Codice servizio:\n");
     scanf("%d",&p->codservizio);
     printf("Durata servizio in ore:\n");
     scanf("%ld",&p->durata);
     printf("Giorno della settimana (0=lun, 1=mar, 5=sab)\n");
     scanf("%d",&p->giorno);
}


void in_lista(struct atomo *L[6])
{
     struct prenotazione p;
     struct atomo *aux;
     int i;

     aux=malloc (sizeof(struct atomo));
     if(aux==NULL)
          return;
     leggi_prenotazione(&p);
    
     i=p.giorno;
     aux->dato=p;
     aux->next=L[i];
     L[i]=aux;
}

void elimina(struct atomo *L[6])
{
     struct atomo *l1,l2;
     int i;
     int g;
     
     printf("Giorno della settimana:\n");
     scanf("%d",&g);
     
     
     if(L[g]==NULL)
     {
          printf("Nessuna prenotazione per questo giorno\n");
          return;
     }
     /* eliminazione di tutti gli elementi della lista dopo averli visualizzati */
     while (L[g]!=NULL)
      {  
            printf("Codice iscritto:%d\n",L[g]->dato.codice);
            printf("Codice servizio: %d\n",L[g]->dato.codservizio);
            printf("Durata servizio: %d\n\n",L[g]->dato.durata);
            da_testa(&L[g]);
      }
    
}

void salva(struct iscritto *T[4], int *N)
{
     FILE *pf;
     int i,j;
     
     pf=fopen("iscritti.dat","w");
     if(pf)
     {
           for(i=0;i<4;i++)
               for(j=0;j<N[i];j++)
                     fwrite(&T[i][j],sizeof(struct iscritto),1,pf);
                fclose(pf);
     }
     else printf("Errore in scrittura\n");
}

          
          
